#version 430 core

in VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

// out vec4 color;
layout (location = 0)  out vec4 color;
layout (location = 1)  out vec4 bright;

uniform bool selectedArtefact;
uniform float time;

void main() {	
	// Normalize the pixel coordinates
    // vec2 uv = FragCoord.xy / resolution.xy;

    // Generate a metallic color using a combination of procedural patterns

    vec3 temp_color = vec3(0.0);
	if (selectedArtefact) {
    	temp_color = vec3(
    	    sin(vert.uv.x * 12.0 + time) * 0.8 + 0.8,
    	    cos(vert.uv.y * 12.0 + time) * 0.8 + 0.8,
    	    sin((vert.uv.x + vert.uv.y) * 12.0 + time) * 0.8 + 0.8
    	);


	}else {
    	temp_color = vec3(
        	sin(vert.uv.x * 8.0 + time) * 0.2 + 0.3,
        	cos(vert.uv.y * 8.0 + time) * 0.2 + 0.3,
        	sin((vert.uv.x + vert.uv.y) * 8.0 + time) * 0.2 + 0.3
		);


	}

    // Add specular highlights for a metallic look
    vec2 center = vec2(0.5, 0.5);
    float radius = 0.2;
    float specular = smoothstep(radius, radius + 0.02, distance(vert.uv, center));

    // Apply the metallic color with specular highlights
    color = vec4(temp_color * 0.8 + specular * 0.2, 1.0);
	bright = vec4(0.0f);

	// first, simple proceduarl 
	// if (selectedArtefact) {

	// }

	// OLD proc generation 
	// float a = floor(vert.position_world.x * 0.6);
	// float b = floor(vert.position_world.y * 0.6);
	// if (mod(a+b, 2.0) > 0.5) {  // a+b is odd
	//     color = vec4(1.0, 0.5, 0.5, 1.0); // pink
	// }
	// else {  // a+b is even
	//     color = vec4(0.6, 0.6, 1.0, 1.0); // light blue
	// }

	// bright = vec4(0.0f);

}


